require 'rubilicious' 
require 'md5'
require 'yaml'

  # Allows one to create a post on del.icio.us that is itslef the URL ofr
  # which the postnis tagging.  Quite meta.
  # The initializer must be gigven either :user_name and :password, or
  # :config_file (the name of a YAML file with user_name and password hash
  # values).  You can also pass in :base_tag, or use the default.
class Delinquent

  LibPath = File.expand_path( File.dirname( __FILE__ ) )

  def deform_title( title_str )
    title_str 
  end

  def deform_content( content_str )
    content_str
  end


  def reform_title( title_str )
    title_str 
  end

  def reform_content( content_str )
    content_str
  end
  
  def initialize( opts = {  } )
    @user_name = opts[ :user_name ]
    @password = opts[ :password ]
    @config_file = opts[ :config_file ]
    @base_tag = opts[ :base_tag ] || 'De.linque.nt'        
    adjust_params
    warn "Creating object for '#{@user_name}', '#{@password}'"
    @r =  Rubilicious.new( @user_name, @password )

  end


    # If this file is called directly it invokes +post_from_cli+
    # It expects there to be some value in ARGV.  All the text up to the first
    # '.' character is the description; the remaining text is the extended
    # text.
    # The content is then posted to Del.icio.us
  def post_from_cli
    unless ARGV[0]
      puts 'You must enter some description text, fool!' 
      return
    end
    text = ARGV.join( ' ' )
    ary = text.split( '.' )
    desc = ary.shift
    ext = ary.join( '.' )
    add( desc, ext )
    recent( count = 10 ).each do |post|
      puts post.inspect
    end
  end



    # Adds a new post with the given description and extended text.
    # You can add your own tags by enclsing thme in [ brackets ]
  def add( title, content )
    key_tag = tag
    tags = ''
    if  content =~ /(\[)(.+)(\])/
      tags  = $2
      m = $1 + $2 +$3
      content.gsub!( m, '' )
    end    
    begin
      @r.add( "#{base_url}#{key_tag}", 
              deform_title( title ), 
              deform_content( content ), 
              "#{key_tag}  #{@base_tag} #{tags}" 
             )        
    rescue Exception
      STDERR.puts( "Exception in adding new post: #$!")
    end
  end

  def recent( count = 10 )
    @r.recent(  @base_tag,  count)
  end


  def read_by_tag( tags, count = 10 )
   warn "read by tag"   # DEBUG
   tags.push( @base_tag )
   tags = tags.map{  |t| t.strip }.join( " " )
   warn "Using tags '#{tags}'"

   posts = @r.recent( tags, count )
   
   posts.map! { |post| 
     post['description']  = reform_title( post['description']   )
     post['extended']  = reform_content( post['extended']  )     
     post
   }
   posts
  end

  def self.where_i_live
    File.expand_path( __FILE__ )
  end


 private
  def tag
    "#{@base_tag}#{ts}"
  end

  def base_url
    "http://del.icio.us/#{@user_name}/"
  end
 
 
    # Creates a time stamp string
  def ts
    t = Time.new
    "#{t.year}#{t.mon}#{t.day}#{t.hour}#{t.min}#{t.sec}"
  end

    # See what was passed in to create this object and make sure there is
    # either a  name/password set, or the name of a config file.
    # If no name/password, then grab config from file and assign insance
    # variables
  def adjust_params
    return if ( @user_name and @password )
    unless @config_file
      raise "You need to pass in a user name and passord, or the name of configuration file!"
    end
    params =  YAML.load( IO.read( @config_file ))
    @user_name = params[ 'user_name' ]
    @password  = params[ 'password' ]
    @base_tag = params[ 'base_tag' ]if params[ 'base_tag' ]
  end
end


if __FILE__ == $0  
  Delinquent.new( :config_file => "default.yml" ).post_from_cli
end


